<?php
/**
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 15-12-15
 * Time: 下午11:37
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class plugin_qianfan_forum extends plugin_qianfan
{

    private $_pid = 0;

    public function __construct()
    {
        parent::__construct();
    }

    public function post_qianfan_message($params)
    {
        if( isset($params['param'][0]) && $params['param'][0] )
        {
            if ( $this->cloudhost && $this->cloudsecretkey && $this->allowpush )
            {
                global $_G;
                if( in_array($params['param'][0], array('post_reply_succeed')) )
                {
                    switch( $params['param'][0] )
                    {
                        case 'post_reply_succeed':
                            $this->_pid = isset($params['param'][2]['pid']) ? $params['param'][2]['pid'] : 0;
                            $this->_after_reply();
                            break;
                        default;
                            break;
                    }
                }
            }

        }
        return true;
    }

    /**
     * 回帖成功后
     */
    private function _after_reply()
    {
        global $_G;

        $post_params = array();

        $shouldPush = 0;
        if( in_array( $_G['forum_thread']['fid'], $this->fidpush ) )
        {
            $post_params1 = array(
                'tid' => $_G['forum_thread']['tid']
            );
            if( in_array($_G['forum_thread']['replies'], $this->replypush) )
            {
                $shouldPush = 1;
                $post_params1 = array(
                    'pushreason' => '回复数到达' . $_G['forum_thread']['replies']
                );
            }

            $post_params2 = array();
            if( $this->replynotice && $_G['uid'] != $_G['forum_thread']['authorid'] )
            {
                $shouldPush = 1;
                $post_params2 = array(
                    'authorid' => $_G['forum_thread']['authorid'],
                    'fromuid' => $_G['uid'],
                    'fromusername' => strtoupper($_G['charset']) == 'UTF-8' ? $_G['member']['username'] : diconv(
                        $_G['member']['username'], $_G['charset'], 'UTF-8' ),
                    'threadtitle' => strtoupper($_G['charset']) == 'UTF-8' ? $_G['forum_thread']['subject'] : diconv(
                        $_G['forum_thread']['subject'], $_G['charset'], 'UTF-8' ),
                    'content' => strtoupper($_G['charset']) == 'UTF-8' ? $_GET['message'] : diconv(
                        $_GET['message'], $_G['charset'], 'UTF-8' ),
                    'noteauthor' => 1,
                    'relation_id' => $this->_pid
                );
            }

            if( $shouldPush )
            {
                $post_params = array_merge( $post_params1, $post_params2 );

                $post_params['nonce'] = CodeSign::nonce(32);
                $post_params['codeSign'] = CodeSign::sign($post_params, $this->cloudsecretkey);

                // 请求地址
                $requestUrl = rtrim( $this->cloudhost, '/' ) . '/' . 'remotenote/replynote/note';

                dfsockopen($requestUrl, 0, $post_params, '', 0, '', 1, 1, 'URLENCODE', 1, 0 );
            }
        }
    }
}

class plugin_qianfan_portal extends plugin_qianfan
{

}

class plugin_qianfan_member extends plugin_qianfan
{

}

class plugin_qianfan
{

    public $cloudhost = '';
    public $cloudsecretkey = '';
    public $allowpush = 0;
    public $replynotice = 0;
    public $replypush;
    public $fidpush;

    /*
    public function discuzcode( $params ){

    }
    */

    public function __construct()
    {
        //加载配置缓存
        include_once DISCUZ_ROOT . DIRECTORY_SEPARATOR . 'data' . DIRECTORY_SEPARATOR . 'sysdata' . DIRECTORY_SEPARATOR .
            'cache_qianfan_config.php';

        $this->cloudhost = isset( $qianfan_config['cloud_host'] ) ? $qianfan_config['cloud_host'] :'';
        $this->cloudsecretkey = isset( $qianfan_config['cloud_secretkey'] ) ? $qianfan_config['cloud_secretkey'] : '';
        $this->allowpush = isset( $qianfan_config['cloud_allow_notice'] ) ? $qianfan_config['cloud_allow_notice'] : 0;
        $this->replynotice = isset( $qianfan_config['cloud_reply_notice'] ) ? $qianfan_config['cloud_reply_notice'] : 0;
        $this->replypush = isset( $qianfan_config['cloud_thread_replypush'] ) && is_array( $qianfan_config['cloud_thread_replypush'] ) ?
            $qianfan_config['cloud_thread_replypush'] : array();
        $this->fidpush = isset( $qianfan_config['cloud_fids_push'] ) && is_array( $qianfan_config['cloud_fids_push']
            ) ? $qianfan_config['cloud_fids_push'] : array();
    }

}

/**
 * 签名校验类
 * Class CodeSign
 */
class CodeSign {
    /**
     * 生成随机字符串
     * @param int $length
     * @return string
     */
    public static function nonce($length = 32){
        $chars = "abcdefghijklmnopqrstuvwxyz0123456789";
        $str = "";
        for ($i = 0; $i < $length; $i++) {
            $str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
        }
        return $str;
    }
    /**
     * 生成校验签名
     * 注: params不能包含secret字段，建议设置随机字符串避免重放攻击
     * @param array $params 参加校验的数组，文件参数不参与校验
     * @param string $secret 密钥
     * @return string
     */
    public static function sign($params,$secret){
        ksort($params);
        $sparams = array();
        foreach ($params as $k => $v) {
            if ("@" != substr($v, 0, 1)) {
                $sparams[] = "$k=$v";
            }
        }
        $sparams[] = "secret=" . $secret;
        return strtoupper(md5(implode("&", $sparams)));
    }
    /**
     * 检查请求签名
     * @param array $params 完整的请求参数
     * @param string $signname 参数中签名的字段名
     * @param string $secret 密钥
     * @return bool
     */
    public static function check($params,$signname,$secret){
        $tmpparams = $params;
        $requestsign = $params[$signname];
        if (isset($tmpparams[$signname])) {
            unset($tmpparams[$signname]);
            $sign = self::sign($tmpparams, $secret);
            return $sign === $requestsign;
        }
        else {
            return false;
        }
    }
}