<?php
/**
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 16/2/22
 * Time: 下午12:38
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class PluginController extends Controller implements TplInterface
{

    public $scriptPath;

    public $staticPath;

    public function init()
    {
        $this->staticPath = rtrim( Yii::app()->getBasePath() , DIRECTORY_SEPARATOR) . DIRECTORY_SEPARATOR . '..' .
            DIRECTORY_SEPARATOR . 'static' . DIRECTORY_SEPARATOR;

        $this->_init_config();
    }

    /**
     * 初始化插件配置
     */
    private function _init_config()
    {
        global $qianfan_config, $_G;

        //项目编码
        Yii::app()->charset = $_G['charset'];

        //项目编码
        Yii::app()->params['site_charset'] = $_G['charset'];

        // 云服务器域名
        Yii::app()->params['cloud_host'] = isset( $qianfan_config['cloud_host'] ) ? $qianfan_config['cloud_host'] : '';
        // 云服务器通信秘钥
        Yii::app()->params['cloud_secretkey'] = isset( $qianfan_config['cloud_secretkey'] ) ? $qianfan_config['cloud_secretkey'] : '';
        //刷新阅读量配置
        Yii::app()->params['cloud_reads'] = isset( $qianfan_config['cloud_reads'] ) ? $qianfan_config['cloud_reads'] : '1';
        //是否允许通知云端
        Yii::app()->params['cloud_allow_notice'] = isset( $qianfan_config['cloud_allow_notice'] ) ? $qianfan_config['cloud_secretkey'] : 0;
        //回帖是否允许通知云端
        Yii::app()->params['cloud_reply_notice'] = isset( $qianfan_config['cloud_reply_notice'] ) ? $qianfan_config['cloud_reply_notice'] : 0;
        //允许将帖子推送云端的版块
        Yii::app()->params['cloud_fids_push'] = isset( $qianfan_config['cloud_fids_push'] ) && is_array( $qianfan_config['cloud_fids_push'] ) ?
            $qianfan_config['cloud_fids_push'] : array();
        //帖子推送的阀值
        Yii::app()->params['cloud_thread_replypush'] = isset( $qianfan_config['cloud_thread_replypush'] ) && is_array( $qianfan_config['cloud_thread_replypush'] ) ? $qianfan_config['cloud_thread_replypush'] : array();

    }

    /**
     * @param $var
     * @param array $params
     * @param string $tpl
     * @return string
     */
    public function tplLang( $var, $params = array(), $tpl = 'tpl' )
    {
        return Tool::getInstance()->tplLang( $var, $params, $tpl );
    }

    /**
     * 返回JS文件
     * @param $file
     * @return mixed|string
     */
    public function getScriptFile( $file )
    {
        $file = $this->scriptPath . $file;

        if( strtoupper(Yii::app()->charset) == 'GBK' && is_file( str_replace( '.js', '_gbk.js', $file ) ) )
        {
            return str_replace( '.js', '_gbk.js', $file );
        }

        return $file;
    }

    /**
     * 处理AJAX返回
     * @param $data
     */
    public function ajaxResponse($data)
    {
        global $_G;

        Yii::app()->charset = 'UTF-8';
        $response = CJSON::encode($data);
        Yii::app()->charset = $_G['charset'];

        return $response;
    }
}