<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/24
 * Time: 下午2:38
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ForumController extends Controller
{

    /**
     * 板块分类
     */
    public function actionForumcategory()
    {
        $forumGroups = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d ORDER BY displayorder ASC", array( 'forum_forum', 'group', 1 ));

        $all = array('forums' => array());
        if( !empty( $forumGroups ) )
        {
            foreach( $forumGroups as $key => $group )
            {
                $g = array();
                $forums = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d AND fup = %d", array( 'forum_forum', 'forum', 1, $group['fid'] ));

                $g['fid'] = $group['fid'];
                $g['name'] = Tool::getInstance()->stripHtmlTags( $group['name'] );
                $g['child'] = array();

                if( !empty( $forums ) )
                {
                    foreach( $forums as $k => $v )
                    {
                        $g['child'][$k]['fid'] = $v['fid'];
                        $g['child'][$k]['name'] = Tool::getInstance()->stripHtmlTags( $v['name'] );
                        $g['child'][$k]['isFavored'] = 0;
                        $g['child'][$k]['tpost'] = 0;
                        $g['child'][$k]['lastpost'] = '';
                        $g['child'][$k]['lastposter'] = '';
                        $g['child'][$k]['contentmin'] = 0;
                        $g['child'][$k]['child'] = array();
                        $subs = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d AND fup = %d", array( 'forum_forum', 'sub', 1, $v['fid'] ));
                        if( !empty($subs) )
                        {
                            foreach( $subs as $j => $s )
                            {
                                $g['child'][$k]['child'][$j]['fid'] = $s['fid'];
                                $g['child'][$k]['child'][$j]['name'] = Tool::getInstance()->stripHtmlTags( $s['name'] );
                                $g['child'][$k]['child'][$j]['isFavored'] = 0;
                                $g['child'][$k]['child'][$j]['tpost'] = 0;
                                $g['child'][$k]['child'][$j]['lastpost'] = '';
                                $g['child'][$k]['child'][$j]['lastposter'] = '';
                                $g['child'][$k]['child'][$j]['contentmin'] = 0;
                            }
                        }
                    }
                }

                $all['forums'][] = $g;
            }
        }

        Tool::getInstance()->success_json( $all );
    }

    /**
     * 主题列表
     * 注意点
     * 是否显示置顶帖
     * 是否显示附件
     * 性能调优
     */
    public function actionGetthreads()
    {
        //板块ID
        $fid = Yii::app()->request->getPost( 'fid', 0 );
        //只看精华帖
        $digest = Yii::app()->request->getPost( 'digest', 0 );
        //排序方式  1 发帖日期倒序 0 最后回复时间倒序
        $ordertype = Yii::app()->request->getPost( 'ordertype', 0 );
        //SQL OFFSET
        $offset = dintval( Yii::app()->request->getPost( 'offset', 0 ) );
        //SQL LIMIT
        $limit = dintval( Yii::app()->request->getPost( 'limit', 0 ) );
        //上次列表页最后的帖子ID
        $lastid = dintval( Yii::app()->request->getPost( 'lastid', 0 ) );
        //是否显示图片附件
        $isshowattach = Yii::app()->request->getPost( 'isshowattach', 0 );
        //是否显示置顶帖
        $showtopthread = WebHelper::getPost('showtopthread', 0);

        global $_G;
        if( $fid > 0 )
        {
            if( !function_exists('loadforum') )
            {
                require_once( libfile( 'function/forum' ) );
            }
            require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );

            loadforum( $fid );
            //检查是否该板块不存在
            if( !$_G['forum']['fid'] )
            {
                Tool::getInstance()->fail_json( Code::FORUM_NOT_EXISTS, Tool::getInstance()->lang('forum not exists') );
            }

            //板块阅读权限判断
            if( $_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm']) && !$_G['forum']['allowview'] )
            {
                $res = qf_showmessagenoperm( 'viewperm', $_G['fid'], $_G['forum']['formulaperm'] );
                Tool::getInstance()->fail_json( Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags( lang('message' ,$res['message'], $res['params']) ) );
            }
            //限定只有某些用户能访问板块
            elseif ( $_G['forum']['formulaperm'] ) {
                $msg = qf_formulaperm($_G['forum']['formulaperm']);
                if ($msg['message'] != '') {
                    Tool::getInstance()->fail_json( Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags( lang('message', $msg['message'], $msg['params']) ) );
                }
            }

            //需要输入密码才能访问板块，由于客户端目前无法让用户手动输入密码，所以直接抛出错误，管理员可以访问
            if( $_G['forum']['password'] && !$_G['forum']['ismoderator'] )
            {
                Tool::getInstance()->fail_json( Code::FORUM_NEED_PASSWORD,  Tool::getInstance()->lang('need password view forum') );
            }

            //板块需要付费才能浏览，版主、管理员默认能访问
            //直接抛出错误，暂未判断其付费记录
            if($_G['forum']['price'] && !$_G['forum']['ismoderator'])
            {
                Tool::getInstance()->fail_json( Code::FORUM_NEED_PRICE, Tool::getInstance()->lang('need price view forum') );
            }



            // 置顶帖处理
            $topLists = array();
            if( $showtopthread && !$offset )
            {
                loadcache('globalstick', 'forumstick');

                $thisgid = $_G['forum']['type'] == 'forum' ? $_G['forum']['fup'] : (!empty($_G['cache']['forums'][$_G['forum']['fup']]['fup']) ? $_G['cache']['forums'][$_G['forum']['fup']]['fup'] : 0);
                $stickytids = '';
                $forumstickytids = array();

                if($_G['setting']['globalstick'] && $_G['forum']['allowglobalstick']) {
                    $stickytids = explode(',', str_replace("'", '', $_G['cache']['globalstick']['global']['tids']));
                    if(!empty($_G['cache']['globalstick']['categories'][$thisgid]['count'])) {
                        $stickytids = array_merge($stickytids, explode(',', str_replace("'", '', $_G['cache']['globalstick']['categories'][$thisgid]['tids'])));
                    }

                    if($_G['forum']['status'] != 3) {
                        $stickycount = $_G['cache']['globalstick']['global']['count'];
                        if(!empty($_G['cache']['globalstick']['categories'][$thisgid])) {
                            $stickycount += $_G['cache']['globalstick']['categories'][$thisgid]['count'];
                        }
                    }
                }

                if($_G['forum']['allowglobalstick']) {
                    $forumstickycount = 0;
                    $forumstickfid = $_G['forum']['status'] != 3 ? $_G['fid'] : $_G['forum']['fup'];
                    if(isset($_G['cache']['forumstick'][$forumstickfid])) {
                        $forumstickycount = count($_G['cache']['forumstick'][$forumstickfid]);
                        $forumstickytids = $_G['cache']['forumstick'][$forumstickfid];
                    }
                    if(!empty($forumstickytids)) {
                        $stickytids = array_merge($stickytids, $forumstickytids);
                    }
                }

                if(is_array($stickytids) && $stickytids[0])
                {
                    $filterarr1 = array(
                        'inforum' => '',
                        'intids' => $stickytids,
                        'displayorder' => array(2, 3, 4)
                    );
                    $topLists = C::t('forum_thread')->fetch_all_search($filterarr1, 0, 0, 20, 'displayorder DESC,
                    lastpost DESC', '');
                }
            }

            //开始获取帖子列表
            $filterarr = array(
                'inforum' => $_G['fid'],
                'sticky' => 4,
                'displayorder' => $showtopthread ? array(0, 1) : array(0)
            );
            //关联其他版块
            if($_G['forum']['relatedgroup']) {
                $relatedgroup = explode(',', $_G['forum']['relatedgroup']);
                $relatedgroup[] = $_G['fid'];
                $filterarr['inforum'] = $relatedgroup;
            } else {
                $filterarr['inforum'] = $_G['fid'];
            }
            //获取精华帖
            if($digest) {
                $filterarr = array(
                    'digest' => 1,
                    'inforum' => $filterarr['inforum'],
                    'sticky' => 4,
                    'displayorder' => array(0)
                );
            }
            //主题帖排序
            $order = 'displayorder DESC, ';
            if( $ordertype )
            {
                $order .= 'dateline DESC';
            }
            else
            {
                $order .=  'lastpost DESC';
            }
            $threadlist = C::t('forum_thread')->fetch_all_search($filterarr, 0, $offset, $limit, $order, '');
            $threadlist = array_merge( $topLists, $threadlist );

            $threads = array();
            if( !empty( $threadlist ) ) {
                foreach ($threadlist as $key => $val)
                {
                    $thread = array();
                    $thread['fid'] = $val['fid'];
                    $thread['fname'] = $_G['forum']['name'];
                    $thread['tid'] = intval($val['tid']);
                    $thread['subject'] = $val['subject'];
                    $thread['authorid'] = $val['authorid'];
                    $thread['author'] = $val['author'];
                    $thread['icon'] = discuz_uc_avatar( $val['authorid'], 'big', 1 );
                    $thread['postdate'] = $val['dateline'];
                    $thread['lastpost'] = $val['lastpost'];
                    $thread['lastposter'] = $val['lastposter'];
                    $thread['favors'] = $val['recommend_add'];
                    $thread['hits'] = $val['views'];
                    $thread['replies'] = $val['replies'];
                    $thread['digest'] = $val['digest'] ? 1 : 0;
                    $thread['special'] = $val['special'];
                    $thread['ifupload'] = $val['attachment'] == 2 ? 1 : 0;
                    $thread['topped'] = $val['displayorder'] > 0 ? 1 : 0;
                    $thread['attach'] = array();

                    $thread['pid'] = DB::result_first("SELECT pid FROM %t WHERE tid = %d AND first = 1", array("forum_post" , $thread['tid']));
                    //获取帖子附件
                    if( $isshowattach && ($val['attachment'] == 2 || $val['attachment'] == 1) )
                    {
                        $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'tid:' . $val['tid'], 'tid', $val['tid'], '', 1 );
                        if( !empty($attachs) )
                        {
                            $i = 0;
                            foreach( $attachs as $k => $attach )
                            {
                                if($thread['pid'] == $attach['pid'])
                                {
                                    if (!$attach['isimage']) continue;
                                    $thread['attach'][] = ForumThread::getAttachUrl($attach);
                                    $i++;
                                }
                            }
                            $thread['attnum'] = ''.$i;
//                            $thread['attnum'] = '' . count($attachs);
                        }
                    }

                    $addviews = DB::result_first("SELECT addviews FROM %t WHERE tid=%d", array("forum_threadaddviews", $val['tid']));
                    $thread['hits'] += $addviews;

                    $threads[] = $thread;
                }
            }

            Tool::getInstance()->success_json( $threads );
        }
    }

    public function actionAllthreads()
    {
        $fid = WebHelper::getPost('fid', 0);
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 0);

        global $_G;

        $threads = array();
        if( $fid )
        {
            $threads = $this->_allThreadByFid($fid, $offset, $limit);
        }
        else
        {
            $threads = $this->_allThread( $offset, $limit );
        }

        $data = array();
        if( !empty($threads) )
        {
            $offset = 0;
            foreach( $threads as $key => $val )
            {
                $data[$offset]['tid'] = $val['tid'];
                $data[$offset]['subject'] = $val['subject'];
                $data[$offset]['authorid'] = $val['authorid'];
                $data[$offset]['author'] = $val['author'];
                $data[$offset]['fid'] = $val['fid'];
                $data[$offset]['forumname'] = DB::result_first("SELECT name FROM %t WHERE fid = %d", array
                ('forum_forum', $val['fid']));
                $data[$offset]['hits'] = $val['views'];
                $data[$offset]['replies'] = $val['replies'];
                $data[$offset]['postdate'] = $val['dateline'];
                $data[$offset]['attachs'] = array();
                if( $val['attachment'] == 2 )
                {
                    $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'tid:' . $val['tid'], 'tid', $val['tid'], '', 1 );
                    if( !empty($attachs) )
                    {
                        foreach( $attachs as $k => $attach )
                        {
                            $data[$offset]['attachs'][] = ForumThread::getAttachUrl($attach);
                        }
                    }
                }


                $offset++;
            }
        }

        Tool::getInstance()->success_json( $data );
    }

    private function _allThreadByFid( $fid, $offset, $limit )
    {
        return DB::fetch_all("SELECT * FROM %t WHERE fid=%d AND displayorder >= %d ORDER by dateline DESC " .
            DB::limit($offset, $limit), array('forum_thread', $fid, 0));
    }

    private function _allThread($offset, $limit)
    {
        return DB::fetch_all( "SELECT * FROM %t WHERE displayorder >= %d ORDER BY dateline DESC " . DB::limit( $offset,
                $limit ), array( 'forum_thread', 0 ) );
    }

    /**
     * 24小时热点帖子列表
     *
     * 只取当前前10000贴
     * 预留后台版块筛选功能
     * 预留后台热度控制
     * 注意性能问题
     */
    public function actionGethotthreads()
    {
        global $_G;
        $order = WebHelper::getPost('order', '');
        $time = WebHelper::getPost('time', '');
        $offset = WebHelper::getPost('offset', '');
        $limit = WebHelper::getPost('limit', '');
        $fids = WebHelper::getPost('fids', '');
        $heatslimit = WebHelper::getPost('heatslimit', '');

        $start = !empty($offset)? intval($offset) : 0;
        $heatslimit = !($heatslimit=='') ? intval($heatslimit) : 3;
        $num = $limit ? intval($limit) : 20;
        $fids = $fids ? explode(',', $fids ) : 0;
        if($heatslimit == 0 && $order == 'hits') {
            $order = 'postdate';
        }

        //热帖的时间范围
        $current = 0;
        if( $order == 'hits') {
            $current = time() - $time;
        }

//        //显示在热帖列表里帖子的热度的最小值 - 改为由后台控制2016-05-03
//        $heatslimit = $_G['setting']['heatthread']['guidelimit'];

        //热点帖子，最新发布，最新回复
        switch( !empty($order) ) {
            case $order == 'hits';
                $order = 'hot';
                break;
            case $order == 'postdate';
                $order = 'newthread';
                break;
            case $order == 'lastpost';
                $order = 'reply';
                break;
            default:
                $order = 'reply';
        }

        //版块过滤
        if(!$fids) {
            loadcache('forums');
            $fids = array();
            foreach ($_G['cache']['forums'] as $fid => $forum) {
                if ($forum['type'] != 'group' && $forum['status'] > 0 && !$forum['viewperm'] && !$forum['havepassword']) {
                    $fids[] = $fid;
                }
            }
        }

        if( !function_exists('loadforum') )
        {
            require_once( libfile( 'function/forum' ) );
        }

        //只取前10000贴
        $limittid = DB::result_first('
            SELECT tid
            FROM %t
            ORDER BY tid DESC
            LIMIT %d
            ',
            array('forum_thread', 1));
        $limittid = intval($limittid) - 10000;
        $limittid = $limittid > 0 ? $limittid : 0;
        $threadlist = C::t('forum_thread')->fetch_all_for_guide($order, $limittid, null, $heatslimit, $current, $start , $num, $fids);

        $data = array();
        foreach($threadlist as $k => $v) {
            $temp['tid'] = $v['tid'];
            $temp['subject'] = $v['subject'];
            $temp['authorid'] = $v['authorid'];
            $temp['author'] = $v['author'];
            $temp['authoricon'] = discuz_uc_avatar( $temp['authorid'], 'big', 1 );
            $temp['fid'] = $v['fid'];
            $foruminfo = C::t('forum_forum')->fetch_info_by_fid($temp['fid']);
            $temp['forumname'] = $foruminfo['name'];

            //修正帖子查看数
            $_GET['tid'] = dintval($v['tid']);
            loadforum();
            if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $v['tid'] && $_G['forum_thread']['views'] > $v['views'])
            {
                $v['views'] = strval($_G['forum_thread']['views']);
            }
            $temp['hits'] = $v['views'];
            $temp['replies'] = $v['replies'];
            $temp['postdate'] = $v['dateline'];
            $temp['lastpost'] = $v['lastpost'];
            $temp['attnum'] = '0';

            //获取附件
            $attach = array();
            $pre = DB::$db->tablepre;
            $v['pid'] = DB::result_first('SELECT pid FROM '.$pre.'forum_post WHERE tid = '.intval($v['tid']).' AND first = 1');

            if($v['attachment'] == 2 || $v['attachment'] ==1) {
                $attachments = C::t('forum_attachment')->fetch_all_by_id('tid', array($v['tid']));
                if($attachments && is_array($attachments) && !empty($attachments)) {
                    $i = 1;
                    foreach ($attachments as $attachment) {
                        if($v['pid'] == $attachment['pid']){
                            $table_index = $attachment['tableid'];
                            $attachment = C::t('forum_attachment_n')->fetch($table_index, $attachment['aid'], false);
                            if(!$attachment['isimage']) continue;
                            //获取附件数量
                            $temp['attnum'] = C::t('forum_attachment_n')->count_image_by_id($table_index,'pid',$attachment['pid']);

                            if( $temp['attnum'] == 2 ) {
                                if($i>1)break;
                            }else {
                                if($i>3)break;
                            }

                            if( !empty($attachment) ) {
                                /*
                                if(strpos($_G['setting']['attachurl'],'http://') === false){
                                    $att_url = $_G['setting']['discuzurl'].'/';
                                }else{
                                    $att_url = '';
                                }
                                */
                                if( $attachment['remote'] == 1 ) {
                                    //$attach[] = 'forum/'.$attachment['attachment'];
                                    $attach[] = $_G['setting']['ftp']['attachurl'].'forum/' . $attachment['attachment'];
                                }
                                else {
                                    $attach[] = $_G['setting']['attachurl'].'forum/'.$attachment['attachment'];
                                }
                            }
                            $i++;
                        }
                    }
                }
            }
            $temp['attachs'] = $attach;
            $data[] = $temp;
        }
        Tool::getInstance()->success_json($data);
    }

	/*
     * 置顶贴
     *
	*/
    public function actionTopthread()
    {
        //板块ID
        $fid = WebHelper::getPost('fid', 0);

        if ($fid > 0) {
            $parameter = array(C::t('forum_thread')->get_table_name(), $fid,1);

            $threadlist_fid =  DB::fetch_all("SELECT * FROM %t WHERE fid=%d AND displayorder=%d ORDER by lastpost DESC  ".DB::limit(0, 20), $parameter);
            $threadlist_all =  DB::fetch_all("SELECT * FROM %t WHERE displayorder=%d ORDER by lastpost DESC".DB::limit(0, 20), array(C::t('forum_thread')->get_table_name(),3));
            $threadlist_gid =  DB::fetch_all("SELECT * FROM %t WHERE displayorder=%d ORDER by lastpost DESC".DB::limit(0, 20), array(C::t('forum_thread')->get_table_name(),2));
            //分区id
            $gid = DB::fetch_all("SELECT fup FROM %t WHERE fid=%d",array('forum_forum',$fid));
            $fids = array();
            if($gid[0]['fup']){
                $fids = DB::fetch_all("SELECT fid FROM %t WHERE fup=%d",array('forum_forum',$gid[0]['fup']));
            }
            //排除其他分区的分类置顶
            if(!empty($fids)){
                foreach($fids as &$value){
                   $value = $value['fid'];
                }
                foreach($threadlist_gid as $k => $v){
                    if(!in_array( $v['fid'],$fids)){
                        unset($threadlist_gid[$k]);

                    }
                }
            }

            $threadlist = array_merge($threadlist_all,$threadlist_gid,$threadlist_fid);
            $threads = array();
            foreach ($threadlist as $key => $val)
            {
                $thread = array();
                $thread['tid'] = $val['tid'];
                $thread['subject'] = $val['subject'];
                $thread['authorid'] = $val['authorid'];
                $thread['author'] = $val['author'];
                $thread['postdate'] = $val['dateline'];
                $thread['lastpost'] = $val['lastpost'];
                $thread['hits'] = $val['views'];
                $thread['replies'] = $val['replies'];

                $threads[] = $thread;
            }

            Tool::getInstance()->success_json($threads);
        }
        else
        {
            Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
        }

    }

    /**
     * 根据fid获取版主
     */
    public function actionForummaster()
    {
        global $_G;
        $_G['fid'] = WebHelper::getPost('fid', '');

        $forumfield = C::t('forum_forumfield')->fetch_all_by_fid(array($_G['fid']));
        $moderators = explode("\t", $forumfield[$_G['fid']]['moderators']);
        $data =array();
        if(!$moderators || !is_array($moderators) || empty($moderators)) {
            Tool::getInstance()->success_json($data);
        }

        foreach ($moderators as $moderator) {
            $user = C::t('common_member')->fetch_by_username($moderator);

            if($user['uid'] > 0){
                $data[] = array(
                    'uid' => $user['uid'] ? $user['uid'] : 0,
                    'username' => $user['username'] ? $user['username'] : '',
                    'icon' => avatar( $user['uid'], 'big', true ),
                );
            }
        }
        Tool::getInstance()->success_json($data);
    }
}