<?php
/**
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 15-10-21
 * Time: 上午1:20
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

require_once DISCUZ_ROOT . './config/config_ucenter.php';
require_once DISCUZ_ROOT . './uc_client/client.php';
require_once DISCUZ_ROOT . './uc_client/model/base.php';
require_once DISCUZ_ROOT . './uc_client/model/user.php';

class MemberController extends Controller
{

    /**
     * 用户登录
     */
    public function actionLogin()
    {
        global $_G;

        $username = WebHelper::getPost( 'pwuser', '' );
        $password = WebHelper::getPost( 'pwpwd' , '');

        $_GET['username'] = $username;
        $_GET['password'] = $password;
        $_GET['questionid'] = $_GET['answer'] = '';
        $_GET['loginfield'] = 'username';

        //require_once libfile('function/member');
        require_once libfile('class/member');
        require_once libfile('function/misc');
        require_once libfile('function/mail');
        require_once( libfile('function/forum') );

        loaducenter();

        $invite = getinvite();

        $_G['uid'] = $_G['member']['uid'] = 0;
        $_G['username'] = $_G['member']['username'] = $_G['member']['password'] = '';

        if (trim($_GET['username']) == '') {
            Tool::getInstance()->fail_json( Code::USERNAME_EMPTY, Tool::getInstance()->lang('username can not be empty') );
            //return self::errorInfo('user_name_null');
        }

        if(!($_G['member_loginperm'] = logincheck($_GET['username']))) {
            // 密码错误次数过多，请 15 分钟后重新登录,后面还会进行判断
            Tool::getInstance()->fail_json( Code::LOGIN_PERM, Tool::getInstance()->lang('login fail too many') );
        }

        if(!$_GET['password'] || $_GET['password'] != addslashes($_GET['password'])) {
            // 抱歉，密码空或包含非法字符
            Tool::getInstance()->fail_json( Code::PASSWORD_ILLEGAL, Tool::getInstance()->lang('profile password illegal') );
        }

        //判断是否是手机号
        if( !C::t('common_member')->fetch_uid_by_username($_GET['username']) && preg_match('/^1[34578]{1}\d{9}$/', $_GET['username']) )
        {
            $loginUid = DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array("phonebind", $_GET['username']));

            if( !$loginUid )
            {
                $loginUid = DB::result_first("SELECT uid FROM %t WHERE mobile=%s LIMIT 1", array
                ("common_member_profile", $_GET['username']));
            }

            if( $loginUid )
            {
                $loginUsername = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $loginUid));
                if( $loginUsername )
                {
                    $_GET['username'] = $loginUsername;
                }
                else
                {
                    Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang("password incorrect") );
                }
            }
            else
            {
                Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang("password incorrect") );
            }
        }

        $result = userlogin($_GET['username'], $_GET['password'], $_GET['questionid'], $_GET['answer'], 'username', $_G['clientip']);

        //此处判断，用于绕过登录问题验证
        if ($result['ucresult']['uid'] == '-3') {
            $userInfo = C::t('common_member')->fetch_by_username( $result['ucresult']['username'] );
            $result['ucresult']['uid'] = $userInfo['uid'];
            $result['member'] = $userInfo;
            $result['status'] = 1;
        }
        $uid = $_G['uid'] = $result['ucresult']['uid'];
        $userAvatar = discuz_uc_avatar( $uid, 'big', true );

        //创建登录逻辑对象
        $ctlObj = new logging_ctl();
        $ctlObj->setting = $_G['setting'];

        //账号自动激活功能
        if( $result['status'] == -1 )
        {
            //是否开启账号自动激活
            if( !$ctlObj->setting['fastactivation'] )
            {
                //账号没有激活
                die('fastactivation');
            }
            else
            {
                $init_arr = explode( ',' , $ctlObj->setting['initcredits'] );
                $groupid = $ctlObj->setting['regverify'] ? 8 : $ctlObj->setting['newusergroupid'];
                C::t( 'common_member' )->insert( $uid, $result['ucresult']['username'], md5(random(10)), $result['ucresult']['email'], $_G['clientip'], $groupid, $init_arr );
                $result['member'] = getuserbyuid( $uid );
                $result['status'] = 1;
            }
        }

        if( $result['status'] > 0 )
        {
            // [?]额外的文件
            if($ctlObj->extrafile && file_exists($ctlObj->extrafile)) {
                require_once $ctlObj->extrafile;
            }

            setloginstatus($result['member'], $_GET['cookietime'] ? 2592000 : 0);
            checkfollowfeed();

            C::t('common_member_status')->update($_G['uid'], array('lastip' => $_G['clientip'], 'lastvisit' =>TIMESTAMP, 'lastactivity' => TIMESTAMP));

            $dob_year = getuserprofile( 'birthyear' );
            $dob_month = getuserprofile( 'birthmonth' );
            $dob_day = getuserprofile( 'birthday' );
            $dob = '1990-1-1';
            if( $dob_year > 0 && $dob_month > 0 && $dob_day > 0 )
            {
                $dob = $dob_year . '-' . $dob_month . '-' . $dob_day;
            }


            //关注的版块
            $collectForums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], 'fid', 0, 0, 0);
            $fids = array();
            if( !empty($collectForums) )
            {
                foreach( $collectForums as $key => $value )
                {
                    $fids[] = $value['id'];
                }
            }

            $cookie_key = $_G['config']['cookie']['cookiepre'] . 'saltkey' . '/t' . $_G['config']['cookie']['cookiepre'] . 'auth';
            $cookie_value = $_COOKIE[$_G['config']['cookie']['cookiepre'] . 'saltkey'] . '/t' . $_COOKIE[$_G['config']['cookie']['cookiepre'] . 'auth'];

            $rvrc = 0;
            $money = 0;
            if( !empty( $_G['setting']['extcredits'] ) )
            {
                $extcreditAry = array();
                $offset = 0;
                foreach( $_G['setting']['extcredits'] as $key => $val )
                {
                    if( $offset < 2 )
                    {
                        $extcreditAry[] = $key;
                    }
                    else
                    {
                        break;
                    }
                    $offset;
                }
                $rvrc = getuserprofile( 'extcredits' . $extcreditAry[0] );
                $money = getuserprofile( 'extcredits' . $extcreditAry[1] );
            }
            $phone = $this->_getPhone($_G['uid']);
            $data = array(
                'uid' => $result['member']['uid'],
                'username' => $result['member']['username'],
                'gender' => getuserprofile( 'gender' ),
                'icon' => $userAvatar,
                'birthday' => $dob,
                'shortcut' => $fids ? implode(',', $fids) : '',
                'rvrc' => $rvrc,
                'money' => $money,
                'honor' => DB::result_first("SELECT sightml FROM %t WHERE uid=%d LIMIT 1", array("common_member_field_forum", $_G['uid'])),
                'phone' => $phone ? $phone : '',
                'email' => getuserprofile('email'),
                'regdate' => getuserprofile('regdate'),
                'postnum' => 0,
                'ltitle' => $_G['group']['grouptitle'],
                'isfollowed' => 0,
                'replycount' => 0,
                'favorcount' => 0,
                'bbscookiename' => $cookie_key,
                'bbscookievalue' => $cookie_value,
                'token' => authcode( $result['member']['password'] . "\t" . $result['member']['uid'], 'ENCODE',
                    Yii::app()
                        ->params['cloud_secretkey'] . $_G['config']['security']['authkey'])//$cookie_value
            );

            Tool::getInstance()->success_json( $data );
        }
        else
        {
            $password = preg_replace("/^(.{".round(strlen($_GET['password']) / 4)."})(.+?)(.{".round(strlen($_GET['password']) / 6)."})$/s", "\\1***\\3", $_GET['password']);
            $errorlog = dhtmlspecialchars(
                TIMESTAMP."\t".
                ($result['ucresult']['username'] ? $result['ucresult']['username'] : $_GET['username'])."\t".
                $password."\t".
                "Ques #".intval($_GET['questionid'])."\t".
                $_G['clientip']);
            writelog('illegallog', $errorlog);
            loginfailed($_GET['username']);

            if($_G['member_loginperm'] > 1) {
                // 登录失败,还可以尝试几次
                Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang( 'remain {left} times', array('{left}' => $_G['member_loginperm'] - 1) ) );
                //return self::errorInfo(lang('message', 'login_invalid',array('loginperm' => $_G['member_loginperm'] - 1)));
            } elseif($_G['member_loginperm'] == -1) {
                // 抱歉，您输入的密码有误
                Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang( 'password incorrect' ) );
                //return self::errorInfo(lang('message', 'login_password_invalid'));
            } else {
                // 密码错误次数过多，请 15 分钟后重新登录
                Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang( 'login fail too many' ) );
                //return self::errorInfo(lang('message', 'login_strike'));
            }
        }

    }

    /**
     * 第三方登录
     */
    public function actionThirdLogin()
    {
        global $_G;

        // 加载UCENTER设置
        loaducenter();

        //第三方OPENID
        $openid = WebHelper::getPost( 'openid', '' );
        //微信UNIONID
        $unionid = WebHelper::getPost( 'unionId', '' );
        //第三方平台
        $weibotype = WebHelper::getPost( 'weibotype', '' );

        $nickname = WebHelper::getPost( 'nickname', '' );

        $uid = 0;
        if( $unionid || $openid )
        {
            if( $unionid )
            {
                // 兼容安卓之前版本注册没有传入unionid的情况
                if($openid) {
                    $uid = DB::result_first("SELECT uid FROM %t WHERE openid = %s AND weibotype = %s LIMIT 1", array(
                        'thirdbind',
                        $openid,
                        $weibotype
                    ));
                    $uid1 = DB::result_first( "SELECT uid FROM %t WHERE unionid = %s AND weibotype = %s LIMIT 1", array(
                        'thirdbind',
                        $unionid,
                        $weibotype
                    ) );
                    if($uid && !$uid1){
                        DB::update("thirdbind", array("unionid" => $unionid), array('uid'=>$uid, 'weibotype'=>$weibotype));
                    }
                    if($uid && $uid1 && $uid != $uid1) {
                        DB::update("thirdbind", array("unionid" => $unionid), array('uid'=>$uid, 'weibotype'=>$weibotype));
                        DB::update("thirdbind", array("unionid" => ''), array('uid'=>$uid1, 'weibotype'=>$weibotype));
                    }
                }

                $uid = DB::result_first( "SELECT uid FROM %t WHERE unionid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $unionid,
                    $weibotype
                ) );

            }
            else
            {
                $uid = DB::result_first( "SELECT uid FROM %t WHERE openid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $openid,
                    $weibotype
                ) );
            }

        }

        if( !$uid )
        {
            $uid = DB::result_first( "SELECT uid FROM %t WHERE conopenid = %s LIMIT 1", array(
                'common_member_connect',
                $openid
            ) );
        }

        if( !$uid )
        {
            Tool::getInstance()->fail_json( Code::THIRD_ACCOUNT_NOT_BIND, Tool::getInstance()->lang( 'third_account_not_bind' ) );
        }

        $user = getuserbyuid( $uid, 1 );

        if( empty($user) )
        {
            Tool::getInstance()->fail_json( Code::USER_NOT_EXISTS, Tool::getInstance()->lang( 'user_not_exists' ) );
        }

        //require_once( libfile('function/member') );
        require_once( libfile('function/forum') );

        setloginstatus($user, $_GET['cookietime'] ? 2592000 : 0);
        checkfollowfeed();

        //更新用户登录操作记录
        C::t('common_member_status')->update($_G['uid'], array('lastip' => $_G['clientip'], 'lastvisit' =>TIMESTAMP, 'lastactivity' => TIMESTAMP));

        // 更新nickname，openid
        if($weibotype == 'wechat' && !empty($unionid)) {
            $sqlArr = array();
            if(!empty($nickname)) {
                $sqlArr['nickname'] = $nickname;
            }
            if(!empty($openid)) {
                $sqlArr['openid'] = $openid;
            }
            DB::update("thirdbind", $sqlArr, array('uid'=>$uid, 'weibotype'=>$weibotype));
        }

        //生日
        $dob_year = getuserprofile( 'birthyear' );
        $dob_month = getuserprofile( 'birthmonth' );
        $dob_day = getuserprofile( 'birthday' );
        $dob = '1990-1-1';
        if( $dob_year > 0 && $dob_month > 0 && $dob_day > 0 )
        {
            $dob = $dob_year . '-' . $dob_month . '-' . $dob_day;
        }

        //关注的版块
        $collectForums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], 'fid', 0, 0, 0);
        $fids = array();
        if( !empty($collectForums) )
        {
            foreach( $collectForums as $key => $value )
            {
                $fids[] = $value['id'];
            }
        }

        $cookie_key = $_G['config']['cookie']['cookiepre'] . 'saltkey' . '/t' . $_G['config']['cookie']['cookiepre'] . 'auth';
        $cookie_value = $_COOKIE[$_G['config']['cookie']['cookiepre'] . 'saltkey'] . '/t' . $_COOKIE[$_G['config']['cookie']['cookiepre'] . 'auth'];

        //威望、金币设置读取
        $rvrc = 0;
        $money = 0;
        if( !empty( $_G['setting']['extcredits'] ) )
        {
            $extcreditAry = array();
            $offset = 0;
            foreach( $_G['setting']['extcredits'] as $key => $val )
            {
                if( $offset < 2 )
                {
                    $extcreditAry[] = $key;
                }
                else
                {
                    break;
                }
                $offset;
            }
            $rvrc = getuserprofile( 'extcredits' . $extcreditAry[0] );
            $money = getuserprofile( 'extcredits' . $extcreditAry[1] );
        }

        $phone = $this->_getPhone($_G['uid']);

        $data = array(
            'uid' => $_G['uid'],
            'username' => $_G['username'],
            'gender' => getuserprofile( 'gender' ),
            'icon' => discuz_uc_avatar( $_G['uid'], 'big', true ),
            'birthday' => $dob,
            'shortcut' => $fids ? implode(',', $fids) : '',
            'rvrc' => $rvrc,
            'money' => $money,
            'honor' => DB::result_first("SELECT sightml FROM %t WHERE uid=%d LIMIT 1", array("common_member_field_forum", $_G['uid'])),
            'phone' => $phone ? $phone : '',
            'email' => $user['email'] ? $user['email'] : '',
            'regdate' => $user['regdate'],
            'postnum' => 0,
            'ltitle' => '',
            'isfollowed' => 0,
            'replycount' => 0,
            'favorcount' => 0,
            'bbscookiename' => $cookie_key,
            'bbscookievalue' => $cookie_value,
            'token' => authcode( $user['password'] . "\t" . $_G['uid'], 'ENCODE', Yii::app()->params['cloud_secretkey'] . $_G['config']['security']['authkey'])//$cookie_value
        );
        Tool::getInstance()->success_json( $data );
    }

    /**
     * 查找手机号
     */
    public function actionCheckAuthMobile()
    {

        $mobile = WebHelper::getPost( 'mobile', '' );

        // 检查是否是合法手机号
        if( !preg_match( '/^1[34578]{1}\d{9}$/', $mobile ) )
        {
            Tool::getInstance( Code::ILLEGAL_MOBILE, Tool::getInstance()->lang( 'illegal_mobile' ) );
        }

        $uid = DB::result_first( "SELECT uid FROM %t WHERE phone = %s", array( "phonebind", $mobile )  );
        // $result = DB::fetch_first( "SELECT uid FROM %t WHERE mobile = %s", array( "common_member_profile", $mobile ) );

        if( !empty($uid) )
        {
            $username = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid));
            $shortUserName = mb_substr( $username, 0, mb_strlen($username, Yii::app()->charset) - 1, Yii::app()->charset ) . '**';
            Tool::getInstance()->fail_json( Code::MOBILE_EXISTS, Tool::getInstance()->lang( 'mobile_exists', array('{username}' => $shortUserName) ) );
        }

        Tool::getInstance()->success_json( array( 'mobile' => $mobile ) );

    }

    /**
     * 检查用户名
     */
    public function actionCheckUsername()
    {

        $username = trim( WebHelper::getPost( 'username', '' ) );

        if( !$username )
        {
            Tool::getInstance()->fail_json( Code::USERNAME_EMPTY, Tool::getInstance()->lang('username can not be empty') );
        }

        //首先去UCENTER验证，是否存在相同的用户名
        loaducenter();
        $ucenterUser = uc_get_user( $username, 0 );

        if( !empty($ucenterUser) )
        {
            Tool::getInstance()->fail_json( Code::USERNAME_EXISTS, Tool::getInstance()->lang('username_exists') );
        }

        //去DISCUZ MEMBER表中验证是否存在用户
        $discuzUser = DB::fetch_first( "SELECT uid FROM %t WHERE username = %s", array('common_member', $username) );
        if( !empty($discuzUser) )
        {
            Tool::getInstance()->fail_json( Code::USERNAME_EXISTS, Tool::getInstance()->lang('username_exists') );
        }

        Tool::getInstance()->success_json( array( 'username' => $username ) );
    }

    /**
     * 用户注册
     */
    public function actionRegister()
    {
        global $_G;
        //require_once libfile('function/member');
        require libfile('class/member');
        //require_once libfile('function/misc');
        //require_once libfile('function/mail');
        require_once( libfile('function/forum') );
        //loaducenter();
        //创建注册逻辑对象
        $ctlObj = new register_ctl();
        $ctlObj->setting = $_G['setting'];

        $regname =  WebHelper::getPost('regname', '');
        $regpwd =  WebHelper::getPost('regpwd', '');
        $regpwdrepeat =  WebHelper::getPost('regpwdrepeat', '');
        $authmobile =  WebHelper::getPost('authmobile', '');
        $needbindthird =  WebHelper::getPost('needbindthird', '');
        $weibotype =  WebHelper::getPost('weibotype', '');
        $openid =  WebHelper::getPost('openid', '');
        $unionId =  WebHelper::getPost('unionId', '');
        $nickname =  WebHelper::getPost('nickname', '');
        $gender = WebHelper::getPost('gender', '');

        $_GET['username'] = trim($regname);
        $_GET['password'] = $regpwd;
        $_GET['password2'] = $regpwdrepeat;
        $_GET['telphone'] = $authmobile;
        $_GET['email'] = random(15) . 'app@app.com';
        $_GET['needbindthird'] = intval($needbindthird);
        $_GET['weibotype'] = trim($weibotype);
        $_GET['openid'] = trim($openid);
        $_GET['unionid'] = trim($unionId);
        $_GET['nickname'] = trim($nickname);
        $_GET['gender'] = $gender ? intval($gender) : 1;

        $pre = DB::$db->tablepre;
        $email = strtolower(trim($_GET['email']));

        //判断系统是否允许注册
        // 这段原生判断是否关闭注册先取消，主要是启用手机版后，导致手机版的注册状态覆盖了站点的注册状态
        /*
        if (!$ctlObj->setting['regclosed'] && (!$ctlObj->setting['regstatus'] || !$ctlObj->setting['ucactivation'])) {
            if (!$ctlObj->setting['regstatus']) {
                $message = !$ctlObj->setting['regclosemessage'] ? '' : str_replace(array("\r", "\n"), '', $ctlObj->setting['regclosemessage']);
                Tool::getInstance()->fail_json(Code::REGISTER_DISABLE, Tool::getInstance()->lang('register disable {var}', array('{var}' => $message)));
            }
        }
        */
        $sendurl = $ctlObj->setting['sendregisterurl'] ? true : false;

        //app注册绕过邮箱验证
        if(isset($ctlObj->setting['regverify']) && $ctlObj->setting['regverify'] == 1) {
            $ctlObj->setting['regverify'] == 0;
        }

        //新用户注册验证
        if($ctlObj->setting['regverify']) {
            //判断不接受新用户注册的地区限制
            if($ctlObj->setting['areaverifywhite']) {
                $location = $whitearea = '';
                $location = trim(convertip($_G['clientip'], "./"));
                if($location) {
                    $whitearea = preg_quote(trim($ctlObj->setting['areaverifywhite']), '/');
                    $whitearea = str_replace(array("\\*"), array('.*'), $whitearea);
                    $whitearea = '.*'.$whitearea.'.*';
                    $whitearea = '/^('.str_replace(array("\r\n", ' '), array('.*|.*', ''), $whitearea).')$/i';
                    if(@preg_match($whitearea, $location)) {
                        $ctlObj->setting['regverify'] = 0;
                    }
                }
            }
            //判断不接受新用户注册的IP限制
            if($_G['cache']['ipctrl']['ipverifywhite']) {
                foreach(explode("\n", $_G['cache']['ipctrl']['ipverifywhite']) as $ctrlip) {
                    if(preg_match("/^(".preg_quote(($ctrlip = trim($ctrlip)), '/').")/", $_G['clientip'])) {
                        $ctlObj->setting['regverify'] = 0;
                        break;
                    }
                }
            }
        }

        //生成用户组
        $groupinfo = array();
        if($ctlObj->setting['regverify']) {
            $groupinfo['groupid'] = 8;
        } else {
            $groupinfo['groupid'] = $ctlObj->setting['newusergroupid'];
        }

        $fromuid = !empty($_G['cookie']['promotion']) && $ctlObj->setting['creditspolicy']['promotion_register'] ? intval($_G['cookie']['promotion']) : 0;
        $username = isset($_GET['username']) ? $_GET['username'] : '';

        if($_GET['username'] && $_GET['password']){
            //用户未激活
            $activationauth = array();
            if(isset($_GET['activationauth']) && $_GET['activationauth']) {
                $activationauth = explode("\t", authcode($_GET['activationauth'], 'DECODE'));
                if($activationauth[1] != FORMHASH) {
                    showmessage('register_activation_invalid', 'member.php?mod=logging&action=login');
                    Tool::getInstance()->fail_json( Code::REGISTER_ACTIVATION_INVALID, Tool::getInstance()->lang( 'register activation invalid' ) );
                }
                $sendurl = false;
            }
            //后台开启了通过邮件发送注册链接，不能直接注册
            if(!$activationauth && $sendurl) {
                //关闭发送邮箱链接注册
                $sendurl = false;
            }

            //开放了邀请注册，不能直接注册
            $invite = getinvite();
            if($ctlObj->setting['regstatus'] == 2 && empty($invite)) {
                Tool::getInstance()->fail_json( Code::REGISTERATION_INVITE, Tool::getInstance()->lang( 'open registration invite' ) );
            }

            //用户未激活
            $activation = array();
            if(isset($_GET['activationauth']) && $activationauth && is_array($activationauth)) {
                if($activationauth[1] == FORMHASH && !($activation = uc_get_user($activationauth[0]))) {
                    Tool::getInstance()->fail_json( Code::REGISTER_ACTIVATION_INVALID, Tool::getInstance()->lang( 'register activation invalid' ) );
                }
            }
            //判断用户名长度
            $usernamelen = dstrlen($username);
            if($usernamelen < 3) {
                Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_TOOSHORT, Tool::getInstance()->lang( 'profile username tooshort' ) );
            } elseif($usernamelen > 15) {
                Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_TOOLONG, Tool::getInstance()->lang( 'profile username toolong' ) );
            }

            //判断密码长度
            if($ctlObj->setting['pwlength']) {
                if(strlen($_GET['password']) < $ctlObj->setting['pwlength']) {
                    Tool::getInstance()->fail_json( Code::PROFILE_PASSWORD_TOOSHORT, Tool::getInstance()->lang( 'profile password tooshort' ) );
                }
            }

            //判断密码复杂度,第三方注册不判断
            if($_GET['needbindthird'] != 1) {
                if($ctlObj->setting['strongpw']) {
                    $strongpw_str = array();
                    if(in_array(1, $ctlObj->setting['strongpw']) && !preg_match("/\d+/", $_GET['password'])) {
                        $strongpw_str[] = lang('member/template', 'strongpw_1');
                    }
                    if(in_array(2, $ctlObj->setting['strongpw']) && !preg_match("/[a-z]+/", $_GET['password'])) {
                        $strongpw_str[] = lang('member/template', 'strongpw_2');
                    }
                    if(in_array(3, $ctlObj->setting['strongpw']) && !preg_match("/[A-Z]+/", $_GET['password'])) {
                        $strongpw_str[] = lang('member/template', 'strongpw_3');
                    }
                    if(in_array(4, $ctlObj->setting['strongpw']) && !preg_match("/[^a-zA-z0-9]+/", $_GET['password'])) {
                        $strongpw_str[] = lang('member/template', 'strongpw_4');
                    }
                    if($strongpw_str) {
                        Tool::getInstance()->fail_json(Code::PASSWORD_WEAK, Tool::getInstance()->lang('password weak {var}', array('{var}' => implode(',', $message))));
                    }
                }
            }

            //两次输入密码是否一致
            if(empty($ctlObj->setting['ignorepassword'])) {
                if($_GET['password'] !== $_GET['password2']) {
                    Tool::getInstance()->fail_json( Code::PROFILE_PASSWD_NOTMATCH, Tool::getInstance()->lang( 'profile passwd notmatch' ) );
                }

                if(!$_GET['password'] || $_GET['password'] != addslashes($_GET['password'])) {
                    Tool::getInstance()->fail_json( Code::PROFILE_PASSWD_ILLEGAL, Tool::getInstance()->lang( 'profile passwd illegal' ) );
                }
                $password = $_GET['password'];
            } else {
                $password = md5(random(10));
            }

            //判断论坛后台限制IP列表
            if($_G['cache']['ipctrl']['ipregctrl']) {
                foreach(explode("\n", $_G['cache']['ipctrl']['ipregctrl']) as $ctrlip) {
                    if(preg_match("/^(".preg_quote(($ctrlip = trim($ctrlip)), '/').")/", $_G['clientip'])) {
                        $ctrlip = $ctrlip.'%';
                        $ctlObj->setting['regctrl'] = $ctlObj->setting['ipregctrltime'];
                        break;
                    } else {
                        $ctrlip = $_G['clientip'];
                    }
                }
            } else {
                $ctrlip = $_G['clientip'];
            }
            //IP在一定时间内不能注册
            if($ctlObj->setting['regctrl']) {
                if(C::t('common_regip')->count_by_ip_dateline($ctrlip, $_G['timestamp']-$ctlObj->setting['regctrl']*3600)) {
                    Tool::getInstance()->fail_json( Code::REGIP_REGCTRL, Tool::getInstance()->lang( 'regip regctrl', array('{intval}' => $ctlObj->setting['regctrl'] ) ) );

                }
            }
            //同一IP在24小时内只能注册几次
            $setregip = null;
            if($ctlObj->setting['regfloodctrl']) {
                $regip = C::t('common_regip')->fetch_by_ip_dateline($_G['clientip'], $_G['timestamp']-86400);
                if($regip) {
                    if($regip['count'] >= $ctlObj->setting['regfloodctrl']) {
                        Tool::getInstance()->fail_json( Code::REGIP_REGFLOODCTRL, Tool::getInstance()->lang( 'regip regfloodctrl' ) );
                    } else {
                        $setregip = 1;
                    }
                } else {
                    $setregip = 2;
                }
            }

            //UC验证用户注册信息
            $profile = array();
            if(!$activation) {
                //判断手机号是否已经存在
                if( !empty($_GET['telphone']) ) {
                    if( DB::result_first("SELECT uid FROM %t WHERE phone=%s", array('phonebind', $_GET['telphone'])) )
                    {
                        Tool::getInstance()->fail_json( Code::TELPHONE_EXIST, Tool::getInstance()->lang( 'telphone exist' ) );
                    }
                }
                /*
                if(C::t('common_member_profile')->count_by_field('mobile', $_GET['telphone'])) {
                    Tool::getInstance()->fail_json( Code::TELPHONE_EXIST, Tool::getInstance()->lang( 'telphone exist' ) );
                }
                */
                /**UC	检查注册用户是否有效
                >0 : UID
                -1 : 用户名不合法
                -2 : 用户名包含被系统屏蔽的字符
                -3 : 用户名已经存在
                -4 : email 地址无效
                -5 : email 包含不可使用的邮箱域名
                -6 : 该 email 已经被注册
                 **/
                $uid = uc_user_register(addslashes($username), $password, $email, $questionid = '', $answer = '', $_G['clientip']);//把参数$questionid, $answer置为空
                if($uid <= 0) {
                    if($uid == -1) {
                        Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_ILLEGAL, Tool::getInstance()->lang( 'profile username illegal' ) );
                    } elseif($uid == -2) {
                        Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_PROTECT, Tool::getInstance()->lang( 'profile username protect' ) );
                    } elseif($uid == -3) {
                        Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_DUPLICATE, Tool::getInstance()->lang( 'profile username duplicate' ) );
                    } elseif($uid == -4) {
                        Tool::getInstance()->fail_json( Code::PROFILE_EMAIL_ILLEGAL, Tool::getInstance()->lang( 'profile email illegal' ) );
                    } elseif($uid == -5) {
                        Tool::getInstance()->fail_json( Code::PROFILE_EMAIL_DOMAIN_ILLEGAL, Tool::getInstance()->lang( 'profile email domain illegal' ) );
                    } elseif($uid == -6) {
                        Tool::getInstance()->fail_json( Code::PROFILE_EMAIL_DUPLICATE, Tool::getInstance()->lang( 'profile email duplicate' ) );
                    } else {
                        //参数错误
                        Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
                    }
                }
            } else {
                list($uid, $username, $email) = $activation;
            }
            $_G['username'] = $username;
            if(getuserbyuid($uid, 1)) {
                if(!$activation) {
                    uc_user_delete($uid);
                }
                //用户 ID {uid}已经存在
                Tool::getInstance()->fail_json( Code::PROFILE_UID_DUPLICATE, Tool::getInstance()->lang( 'profile uid duplicate' ) );
            }
            $password = md5(random(10));
            $secques = $questionid > 0 ? random(8) : '';

            /*
            if(isset($_POST['birthmonth']) && isset($_POST['birthday'])) {//计算星座
                $profile['constellation'] = get_constellation($_POST['birthmonth'], $_POST['birthday']);
            }
            if(isset($_POST['birthyear'])) {// 计算生肖
                $profile['zodiac'] = get_zodiac($_POST['birthyear']);
            }
            */

            //写入限制注册的IP
            if($setregip !== null) {
                if($setregip == 1) {
                    C::t('common_regip')->update_count_by_ip($_G['clientip']);
                } else {
                    C::t('common_regip')->insert(array('ip' => $_G['clientip'], 'count' => 1, 'dateline' => $_G['timestamp']));
                }
            }

            //写入用户信息
            $emailstatus = 0;
            $init_arr = array('credits' => explode(',', $ctlObj->setting['initcredits']), 'profile'=>$profile, 'emailstatus' => $emailstatus);
            C::t('common_member')->insert($uid, $username, $password, $email, $_G['clientip'], $groupinfo['groupid'], $init_arr);

            //ucenter写入，而论坛写入用户失败时写入日志
            if($uid) {
                $user = DB::fetch_first("SELECT * FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid));
                if(!$user) {
                    $time = date("Y-m-d H:i:s");
                    Yii::log(var_export('QIANFAN-REGISTER-FAILED:uid='.$uid.'----time:'.$time, true));
                }
            }

            //通过邮件验证执行积分策略
            if($emailstatus) {
                //奖励积分
                updatecreditbyaction('realemail', $uid);
            }
            require_once libfile('cache/userstats', 'function');
            build_cache_userstats();

            //更新IP限制信息
            if($ctlObj->setting['regctrl'] || $ctlObj->setting['regfloodctrl']) {
                C::t('common_regip')->delete_by_dateline($_G['timestamp']-($ctlObj->setting['regctrl'] > 72 ? $ctlObj->setting['regctrl'] : 72)*3600);
                if($ctlObj->setting['regctrl']) {
                    C::t('common_regip')->insert(array('ip' => $_G['clientip'], 'count' => -1, 'dateline' => $_G['timestamp']));
                }
            }

            //写入注册用户审核信息
            $regmessage = dhtmlspecialchars($_GET['regmessage']);
            if($ctlObj->setting['regverify'] == 2) {
                C::t('common_member_validate')->insert(array(
                    'uid' => $uid,
                    'submitdate' => $_G['timestamp'],
                    'moddate' => 0,
                    'admin' => '',
                    'submittimes' => 1,
                    'status' => 0,
                    'message' => $regmessage,
                    'remark' => '',
                ), false, true);
                manage_addnotify('verifyuser');
            }

            setloginstatus(array(
                'uid' => $uid,
                'username' => $_G['username'],
                'password' => $password,
                'groupid' => $groupinfo['groupid'],
            ), 0);
            //更新统计用户表
            include_once libfile('function/stat');
            updatestat('register');

            if($fromuid) {
                updatecreditbyaction('promotion_register', $fromuid);
                dsetcookie('promotion', '');
            }
            dsetcookie('loginuser', '');
            dsetcookie('activationauth', '');
            dsetcookie('invite_auth', '');

            //写入注册用户论坛信息
            if( $ctlObj->setting['regverify'] == 1 ) {
                $idstring = random(6);
                $authstr = $ctlObj->setting['regverify'] == 1 ? "$_G[timestamp]\t2\t$idstring" : '';

                C::t('common_member_field_forum')->update($_G['uid'], array('authstr' => $authstr));
                $verifyurl = "{$_G[siteurl]}member.php?mod=activate&amp;uid={$_G[uid]}&amp;id=$idstring";
                $email_verify_message = lang('email', 'email_verify_message', array(
                    'username' => $_G['member']['username'],
                    'bbname' => $ctlObj->setting['bbname'],
                    'siteurl' => $_G['siteurl'],
                    'url' => $verifyurl
                ));
                if(!sendmail("$username <$email>", lang('email', 'email_verify_subject'), $email_verify_message)) {
                    runlog('sendmail', "$email sendmail failed.");
                }
            }
            //手动设置性别
            C::t('common_member_profile')->update($_G['uid'],array(
                'gender'=>$_GET['gender']));

            //注册成功后写入日志
//            $user = DB::fetch_first("SELECT * FROM %t WHERE uid=%d LIMIT 1", array("common_member", $_G['uid']));
//            Yii::log(var_export('QIANFAN-REGISTER:uid='.$user['uid'].'&username='.$user['username'].'&regdate='.$user['regdate'], true));

            //返回用户信息
            $data['uid'] = $_G['uid'];
            $data['username'] = $_G['username'];
            $userinfo = $user_shortcut = array();
            $userinfo = getuserbyuid($_G['uid'],1);
            $usercount = DB::fetch_first("SELECT posts,threads,extcredits1,extcredits2 FROM ".$pre."common_member_count WHERE uid = ".intval($_G['uid']));
            $userprofile = DB::fetch_first("SELECT gender,birthyear,birthmonth,birthday FROM ".$pre."common_member_profile WHERE uid = ".intval($_G['uid']));
            $usershortcut = DB::fetch_all("SELECT id FROM ".$pre."home_favorite WHERE uid = ".intval($_G['uid'])." AND idtype = 'fid'");
            $userfieldforum = DB::fetch_first("SELECT sightml FROM ".$pre."common_member_field_forum WHERE uid = ".intval($_G['uid']));

            foreach($usershortcut as $k => $v){
                $user_shortcut[] = $v['id'];
            }
            $data['shortcut'] = implode(',',$user_shortcut);
            $data['honor'] = $userfieldforum['sightml'];
            $data['gender'] = $userprofile['gender'] ? $userprofile['gender'] : 1;
            $data['icon'] = avatar($_G['uid'], 'middle', true );//$_G['setting']['discuzurl'].'/'.AVATAR_DIR.'/data/avatar/'.get_avatar($_G['uid']);
            $data['birthday'] = $userprofile['birthyear'].'-'.$userprofile['birthmonth'].'-'.$userprofile['birthday'];
            $data['postnum'] = $usercount['threads'];
            $data['phone'] = $_GET['telphone'];
            $data['email'] = $userinfo['email'];
            $data['rvrc'] = $usercount['extcredits1'] ? $usercount['extcredits1'] : 0;
            $data['money'] = $usercount['extcredits2'] ? $usercount['extcredits2'] : 0;
            $data['ltitle'] = $_G['group']['grouptitle'];
            $data['replycount'] = $usercount['posts'];
            $data['favorcount'] = DB::result_first("SELECT COUNT(*) as wa FROM ".$pre."home_favorite WHERE uid = ".intval($_G['uid'])." AND idtype = 'tid'");
            $data['token'] = authcode( $userinfo['password'] . "\t" . $userinfo['uid'], 'ENCODE', Yii::app()->params['cloud_secretkey'] . $_G['config']['security']['authkey'] );
            $data['bbscookiename'] = $_G['config']['cookie']['cookiepre'].'saltkey'.'/t'.$_G['config']['cookie']['cookiepre'].'auth';
            $data['bbscookievalue'] = $_G['cookie']['saltkey'].'/t'.authcode("{$userinfo['password']}\t{$userinfo['uid']}", 'ENCODE');

            //更新手机号
            if(!empty($_GET['telphone'])) {
                DB::insert("phonebind", array(
                    "uid" => $_G['uid'],
                    "phone" => $_GET['telphone'],
                    "dateline" => TIMESTAMP
                ));
            }
//            C::t('common_member_profile')->update($_G['uid'],array('mobile'=>$_GET['telphone'],
//                'gender'=>$_GET['gender']));

            //第三方注册
            if($_GET['needbindthird'] == 1 && $_G['uid']){
                $insertData = array();
                $insertData['uid'] = $_G['uid'];
                $insertData['weibotype'] = $_GET['weibotype'];
                $insertData['openid'] = $_GET['openid'];
                if($_GET['unionid']){
                    $insertData['unionid'] = $_GET['unionid'];
                }
                $insertData['nickname'] = $_GET['nickname'];
                $insertData['dateline'] = time();

                //qq
                if($_GET['weibotype'] == 'qq'){
                    $insertConnect['conopenid'] = $_GET['openid'];
                    $insertConnect['uid'] = $_G['uid'];
                    if($_GET['openid'] && $_G['uid']){
                        $id = DB::insert('common_member_connect',$insertConnect,false);
                        //C::t('#qqconnect#common_member_connect')->insert($insertConnect);
                    }
                    C::t('common_member')->update($_G['uid'],array('conisbind'=>1));
                }else {
                    $id = DB::insert('thirdbind',$insertData,true);
                }
                if(!$id){
                    Tool::getInstance()->fail_json( Code::THIRD_REGISTER_FAILED, Tool::getInstance()->lang( 'third register failed' ) );
                }
            }
            //注册成功
            Tool::getInstance()->success_json( $data );
        }else {
            //参数错误
            Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
        }
    }

    /**
     * 绑定第三方账号
     */
    public function actionBindPlatformAccount()
    {
        $username = WebHelper::getPost('pwuser', '');
        $password = WebHelper::getPost('pwpwd', '');
        $weibotype = WebHelper::getPost('weibotype', '');
        $openid = WebHelper::getPost('openid', '');
        $unionid = WebHelper::getPost('unionid');

        $_GET['username'] = $username;
        $_GET['password'] = $password;
        $_GET['questionid'] = $_GET['answer'] = '';
        $_GET['loginfield'] = 'username';

        require_once libfile('class/member');

        loaducenter();
        $invite = getinvite();

        $_G['uid'] = $_G['member']['uid'] = 0;
        $_G['username'] = $_G['member']['username'] = $_G['member']['password'] = '';

        //用户名是否为空
        if (trim($_GET['username']) == '') {
            Tool::getInstance()->fail_json( Code::USERNAME_EMPTY, Tool::getInstance()->lang('username can not be empty') );
        }

        //判断是否是手机号
        if( !C::t('common_member')->fetch_uid_by_username($_GET['username']) && preg_match('/^1[34578]{1}\d{9}$/', $_GET['username']) )
        {
            $loginUid = DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array("phonebind", $_GET['username']));

            if( $loginUid )
            {
                $loginUsername = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $loginUid));
                if( $loginUsername )
                {
                    $_GET['username'] = $loginUsername;
                }
                else
                {
                    Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang("password incorrect") );
                }
            }
            else
            {
                Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang("password incorrect") );
            }
        }

        // 密码错误次数过多，请 15 分钟后重新登录,后面还会进行判断
        if( !($_G['member_loginperm'] = logincheck($_GET['username'])) ) {
            // 密码错误次数过多，请 15 分钟后重新登录,后面还会进行判断
            Tool::getInstance()->fail_json( Code::LOGIN_PERM, Tool::getInstance()->lang('login fail too many') );
        }

        // 抱歉，密码空或包含非法字符
        if(!$_GET['password'] || $_GET['password'] != addslashes($_GET['password'])) {
            Tool::getInstance()->fail_json( Code::PASSWORD_ILLEGAL, Tool::getInstance()->lang('profile password illegal') );
        }

        //判断是否是手机号
        if( !C::t('common_member')->fetch_uid_by_username($_GET['username']) && preg_match('/^1[34578]{1}\d{9}$/', $_GET['username']) )
        {
            $loginUid = DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array("phonebind", $_GET['username']));

            if( $loginUid )
            {
                $loginUsername = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $loginUid));
                if( $loginUsername )
                {
                    $_GET['username'] = $loginUsername;
                }
                else
                {
                    Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang("password incorrect") );
                }
            }
            else
            {
                Tool::getInstance()->fail_json( Code::PASSWORD_ERROR, Tool::getInstance()->lang("password incorrect") );
            }
        }

        //登录操作
        $result = userlogin($_GET['username'], $_GET['password'], $_GET['questionid'], $_GET['answer'], 'username', $_G['clientip']);

        //此处判断，用于绕过登录问题验证
        if ($result['ucresult']['uid'] == '-3') {
            $userInfo = C::t('common_member')->fetch_by_username( $result['ucresult']['username'] );
            $result['ucresult']['uid'] = $userInfo['uid'];
            $result['member'] = $userInfo;
            $result['status'] = 1;
        }

        $uid = $_G['uid'] = $result['ucresult']['uid'];

        //创建登录逻辑对象
        $ctlObj = new logging_ctl();
        $ctlObj->setting = $_G['setting'];

        //账号自动激活功能
        if( $result['status'] == -1 )
        {
            //是否开启账号自动激活
            if( !$ctlObj->settting['fastactivation'] )
            {
                //账号没有激活
                Tool::getInstance()->fail_json( Code::NOT_ACTIVATION, Tool::getInstance()->lang('location_activation') );
            }
            else
            {
                $init_arr = explode( ',' , $ctlObj->setting['initcredits'] );
                $groupid = $ctlObj->setting['regverify'] ? 8 : $ctlObj->setting['newusergroupid'];
                C::t( 'common_member' )->insert( $uid, $result['ucresult']['username'], md5(random(10)), $result['ucresult']['email'], $_G['clientip'], $groupid, $init_arr );
                $result['member'] = getuserbyuid( $uid );
                $result['status'] = 1;
            }
        }

        if( $result['status'] > 0 )
        {
            //登录成功 绑定功能
            // [?]额外的文件
            if($ctlObj->extrafile && file_exists($ctlObj->extrafile)) {
                require_once $ctlObj->extrafile;
            }

            setloginstatus($result['member'], $_GET['cookietime'] ? 2592000 : 0);
            checkfollowfeed();

            C::t('common_member_status')->update($_G['uid'], array('lastip' => $_G['clientip'], 'lastvisit' =>TIMESTAMP, 'lastactivity' => TIMESTAMP));

            //判断用户是否绑定了同样的第三方账号
            $platform = DB::fetch_first( "SELECT * FROM %t WHERE uid = %d AND weibotype = %s LIMIT 1" , array(
                'thirdbind',
                $_G['uid'],
                $weibotype
            ) );

            if( !empty($platform) )
            {
                Tool::getInstance()->fail_json( Code::BIND_OTHER_PLATFORM, Tool::getInstance()->lang('bind_other_platform') );
            }

            //判断平台账号是否绑定了本地用户
            if( $weibotype == 'wechat' && !empty($unionid) ) {
                $user = DB::fetch_first("SELECT * FROM %t WHERE unionid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $unionid,
                    $weibotype
                ));
            }else {
                $user = DB::fetch_first("SELECT * FROM %t WHERE openid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $openid,
                    $weibotype
                ));
            }

            if( $weibotype == 'qq' && !$user )
            {
                $user = DB::fetch_first( "SELECT * FROM %t WHERE conopenid = %s", array(
                    'common_member_connect',
                    $openid
                ) );
            }

            if( !empty($user) )
            {
                Tool::getInstance()->fail_json( Code::BIND_OTHER_ACCOUNT, Tool::getInstance()->lang('bind_other_account') );
            }

            //处理绑定账号
            $insertData = array();
            $insertData['uid'] = $_G['uid'];
            $insertData['weibotype'] = $weibotype;
            $insertData['openid'] = $openid;
            if( $unionid )
            {
                $insertData['unionid'] = $unionid;
            }

            $platformId = DB::insert( 'thirdbind', $insertData, true );
            if( $weibotype == 'qq' )
            {
                $insertConnect['conopenid'] = $openid;
                $insertConnect['uid'] = $_G['uid'];
                if( $openid && $_G['uid'] )
                {
                    $platformId = DB::insert('common_member_connect', $insertConnect, false);
                    //C::t('#qqconnect#common_member_connect')->insert($insertConnect);
                }
                C::t('common_member')->update($_G['uid'],array('conisbind'=>1));
            }

            if( !$platformId )
            {
                Tool::getInstance()->fail_json( Code::BIND_PLATFORM_FAIL, Tool::getInstance()->lang('bind_platform_fail') );
            }

            Tool::getInstance()->success_json(array());
        }
        else
        {
            Tool::getInstance()->fail_json( Code::BIND_PLATFORM_FAIL, Tool::getInstance()->lang('bind_platform_fail') );
        }

    }

    /**
     * 修改手机号
     */
    public function actionChangemobile()
    {
        $mobile = WebHelper::getPost('mobile', '');

        global $_G;

        // 登录判断
        if( !$_G['uid'] )
        {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }

        // 验证手机号合法性
        if( !preg_match( '/^1[34578]{1}\d{9}$/', $mobile ) )
        {
            Tool::getInstance()->fail_json( Code::ILLEGAL_MOBILE, Tool::getInstance()->lang( 'illegal_mobile' ) );
        }

        // 手机号是否绑定了账号
        if( $uid = DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array('phonebind', $mobile)) )
        {
            $username = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid));
            $shortUserName = mb_substr( $username, 0, mb_strlen($username, Yii::app()->charset) - 1, Yii::app()->charset ) . '**';
            Tool::getInstance()->fail_json( Code::MOBILE_EXISTS, Tool::getInstance()->lang('mobile_exists', array('{username}' => $shortUserName)) );
        }

        if( DB::result_first("SELECT uid FROM %t WHERE uid=%d LIMIT 1", array("phonebind", $_G['uid'])) )
        {
            DB::update( "phonebind", array("phone" => $mobile), "uid=" . $_G['uid'] );
        }
        else
        {
            DB::insert( "phonebind", array("uid" => $_G['uid'], "phone" => $mobile, "dateline" => TIMESTAMP) );
        }

        Tool::getInstance()->success_json(array());
    }

    /**
     * 修改用户资料
     */
    public function actionEditprofile()
    {
        $col = WebHelper::getPost( 'col', 0 );
        $val = WebHelper::getPost( 'val', '' );

        if( $col && $val )
        {
            global $_G;

            if( !$_G['uid'] )
            {
                Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
            }

            //修改性别
            if( $col == 1 )
            {
                if( !in_array($val, array(0,1,2)) )
                {
                    $val = 0;
                }

                C::t('common_member_profile')->update( $_G['uid'], array('gender' => $val) );
            }
            elseif( $col == 2 )
            {
                C::t('common_member_field_forum')->update($_G['uid'], array('sightml' => $val));
            }
            elseif( $col == 3 )
            {
                $birthday = explode('-',$val);
                $setarr['birthyear'] = $birthday['0'];
                $setarr['birthmonth'] = $birthday['1'];
                $setarr['birthday'] = $birthday['2'];
                C::t('common_member_profile')->update($_G['uid'], $setarr);
            }
        }

        Tool::getInstance()->success_json( NULL );

    }

    /**
     * 获取手机号码
     * @param $uid
     * @return string
     */
    public function _getPhone( $uid )
    {
        $phone = DB::result_first("SELECT phone FROM %t WHERE uid=%d LIMIT 1", array("phonebind", $uid));
        if( $phone )
        {
            return $phone;
        }

        $phone = DB::result_first("SELECT mobile FROM %t WHERE uid=%d LIMIT 1", array("common_member_profile", $uid));
        Yii::log(var_export($phone, true));
        if( $phone )
        {
            if( !DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array("phonebind", $phone)))
            {
                DB::insert("phonebind", array(
                    "uid" => $uid,
                    "phone" => $phone,
                    "dateline" => time()
                ));
            }
            return $phone;
        }
        return '';
    }

    /**
     * 验证手机号,发送验证码
     */
    public function actionSend4Login() {
        $mobile = WebHelper::getPost( 'phone', '' );

        // 检查是否是合法手机号
        if( !preg_match( '/^1[34578]{1}\d{9}$/', $mobile ) ) {
            Tool::getInstance()->fail_json( Code::ILLEGAL_MOBILE, Tool::getInstance()->lang( 'illegal_mobile' ) );
        }

        $uid = DB::result_first( "SELECT uid FROM %t WHERE phone = %s", array( "phonebind", $mobile ) );
        if( !$uid ) {
            $uid = DB::result_first("SELECT uid FROM %t WHERE mobile = %s", array("common_member_profile", $mobile));
            if(!$uid) {
                Tool::getInstance()->fail_json( Code::PHONE_NOT_REG, Tool::getInstance()->lang('phone not register') );//lang
            }
        }

        // 生成验证码
        $verifyCode = random(6,int);
        Yii::app()->cache->set( "verify_code_login_" . $mobile, $verifyCode, 600 );
        Tool::getInstance()->success_json(array('code' => $verifyCode));
    }

    /**
     * 短信验证码登录
     *
     */
    public function actionVerifycodeLogin() {
        global $_G;

        $mobile = WebHelper::getPost( 'phone' , '');
        $verifyCode = WebHelper::getPost( 'code' , '');
        if(!$verifyCode) {
            Tool::getInstance()->fail_json(Code::VERIFYCODE_NOT_EXISTS, Tool::getInstance()->lang('verifycode not exists'));//lang 验证码不能为空
        }

        $code = Yii::app()->cache->get("verify_code_login_" . $mobile);
        if($verifyCode != $code || !$code) {
            Tool::getInstance()->fail_json(Code::VERIFYCODE_NOT_CORRECT, Tool::getInstance()->lang('verifycode not correct'));//lang 验证码不正确或已经失效
        }

        // 加载UCENTER设置
        loaducenter();
        $uid = DB::result_first( "SELECT uid FROM %t WHERE phone = %s", array( "phonebind", $mobile ) );
        if(!$uid) {
            $uid = DB::result_first("SELECT uid FROM %t WHERE mobile = %s", array("common_member_profile", $mobile));
            if(!$uid) {
                Tool::getInstance()->fail_json( Code::PHONE_NOT_REG, Tool::getInstance()->lang('phone not register') );
            }
        }

        //登录逻辑
        $user = getuserbyuid( $uid, 1 );
        if( empty($user) ) {
            Tool::getInstance()->fail_json( Code::USER_NOT_EXISTS, Tool::getInstance()->lang( 'user_not_exists' ) );
        }

        require_once( libfile('function/forum') );
        setloginstatus($user, $_GET['cookietime'] ? 2592000 : 0);
        checkfollowfeed();

        //更新用户登录操作记录
        C::t('common_member_status')->update($_G['uid'], array('lastip' => $_G['clientip'], 'lastvisit' =>TIMESTAMP, 'lastactivity' => TIMESTAMP));

        //生日
        $dob_year = getuserprofile( 'birthyear' );
        $dob_month = getuserprofile( 'birthmonth' );
        $dob_day = getuserprofile( 'birthday' );
        $dob = '1990-1-1';
        if( $dob_year > 0 && $dob_month > 0 && $dob_day > 0 )
        {
            $dob = $dob_year . '-' . $dob_month . '-' . $dob_day;
        }

        //关注的版块
        $collectForums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], 'fid', 0, 0, 0);
        $fids = array();
        if( !empty($collectForums) ) {
            foreach( $collectForums as $key => $value )
            {
                $fids[] = $value['id'];
            }
        }

        $cookie_key = $_G['config']['cookie']['cookiepre'] . 'saltkey' . '/t' . $_G['config']['cookie']['cookiepre'] . 'auth';
        $cookie_value = $_COOKIE[$_G['config']['cookie']['cookiepre'] . 'saltkey'] . '/t' . $_COOKIE[$_G['config']['cookie']['cookiepre'] . 'auth'];

        //威望、金币设置读取
        $rvrc = 0;
        $money = 0;
        if( !empty( $_G['setting']['extcredits'] ) ) {
            $extcreditAry = array();
            $offset = 0;
            foreach( $_G['setting']['extcredits'] as $key => $val ) {
                if( $offset < 2 ) {
                    $extcreditAry[] = $key;
                }
                else {
                    break;
                }
                $offset;
            }
            $rvrc = getuserprofile( 'extcredits' . $extcreditAry[0] );
            $money = getuserprofile( 'extcredits' . $extcreditAry[1] );
        }

        $phone = DB::result_first("SELECT phone FROM %t WHERE uid=%d", array('phonebind', $_G['uid']));

        $data = array(
            'uid' => $_G['uid'],
            'username' => $_G['username'],
            'gender' => getuserprofile( 'gender' ),
            'icon' => discuz_uc_avatar( $_G['uid'], 'big', true ),
            'birthday' => $dob,
            'shortcut' => $fids ? implode(',', $fids) : '',
            'rvrc' => $rvrc,
            'money' => $money,
            'honor' => '',
            'phone' => $phone ? $phone : '',
            'email' => $user['email'] ? $user['email'] : '',
            'regdate' => $user['regdate'],
            'postnum' => 0,
            'ltitle' => '',
            'isfollowed' => 0,
            'replycount' => 0,
            'favorcount' => 0,
            'bbscookiename' => $cookie_key,
            'bbscookievalue' => $cookie_value,
            'token' => authcode( $user['password'] . "\t" . $_G['uid'], 'ENCODE', Yii::app()->params['cloud_secretkey'] . $_G['config']['security']['authkey'])//$cookie_value
        );
        Tool::getInstance()->success_json( $data );
    }

    /**
     * 获取第三方登录的用户信息
     */
    public function actionGetThirdInfo() {
        global $_G;

        $openid = WebHelper::getPost('openid', '');
        $unionid = WebHelper::getPost('unionid', '');
        $weibotype = WebHelper::getPost('weibotype', '');

        $result = array();
        if($weibotype == 'wechat') {
            $result = DB::fetch_first("SELECT * FROM %t WHERE unionid=%s AND weibotype=%s", array('thirdbind', $unionid, $weibotype));
        }else if($weibotype == 'qq') {
            $result = DB::fetch_first("SELECT * FROM %t WHERE openid=%s AND weibotype=%s", array('thirdbind', $openid, $weibotype));
            if(!$result) {
                $result = DB::fetch_first("SELECT * FROM %t WHERE conopenid=%s", array('common_member_connect', $openid));
            }
        }else {
            $result = DB::fetch_first("SELECT * FROM %t WHERE openid=%s AND weibotype=%s", array('thirdbind', $openid, $weibotype));
        }
        Tool::getInstance()->success_json( $result );
    }

}